public class AssignStmt extends Statement
  {
  public Id destination;
  public Expression source;
  
  public AssignStmt(Range r, Id d, Expression s) 
    { super(r); destination = d; source = s; }
  public String toString()
    { return "(" + tag() + " label:" + label + "," + destination + "," + source + ")"; }

  public void visit() throws SemanticException 
    { 
    label = Global.nextLabel(); 
    destination.visit(); 
    if (destination.type != Type.VAR && destination.type != Type.FORMAL ) throw
      new SemanticException("`" + destination.spelling + "' is not a variable or a formal parameter; " + destination.range + ".");

    source.visit(); 
    }

  }
