public class CallStmt extends Statement
  {
  public Id name;
  public Expression param;
  
  public CallStmt(Range r, Id n, Expression p) 
    { super(r); name = n; param = p; }
  public String toString()
    { return "(" + tag() + " label:" + label  + "," + name + "," + param + ")"; }

  public void visit() throws SemanticException
    {  
    label = Global.nextLabel(); 
    name.visit(); 
    if (name.type != Type.PROC) throw
      new SemanticException("`" + name.spelling + "' is not a procedure; " + name.range + ".");
    param.visit(); 
    }
  }
