public class NodeList extends Node
  {
  protected Listable first;  
  public NodeList(Range r) { super(r); }
  
  public void append(Listable newChild)
    {
    if (first == null)
      first = newChild;       
    else
      {
      Listable last = first;      
      while (last.next != null) last = last.next;   
      newChild.prev = last;
      last.next = newChild;     
      }
    }
  
  public int length()
    {
    int result = 0;
    for (Listable c = first; c != null; c = c.next) result++;
    return result;
    }

  public void visit() throws SemanticException
    {
    for (Listable c = first; c != null; c = c.next) c.visit();
    }

  public String toString()
    {
    String result = "(" + tag() + ",";
    for (Listable c = first; c != null; c = c.next) result += c + ",";
    result += "null)";
    return result;
    }
  }
