public class ProcDecl extends Decl
  {
  public Id name;
  public FormalParam param;
  public Statements ss;
  
  public ProcDecl(Range r, Id n, FormalParam p, Statements s) 
    { super(r); name = n; param = p; ss = s; }

  public String toString() 
    { return "(" + tag() + "," + name + "," + param + "," + ss + ")"; }

  public void visit() throws SemanticException
    { 
    Entry e = Global.table.lookup(name.spelling);
    if (e != null) throw new SemanticException("The name `" + name.spelling +
                                 "' at " + name.range +
                                 " was already declared.");
    Global.table.enter(name.spelling, this, Type.PROC);

    name.visit(); 
    param.visit(); 
    ss.visit(); 
    Global.table.exitProc();
    }

  }
