public class Range
  {
  public Location first;
  public Location last;

/* ------------------------------------------------------------------------- */

  public Range() {}
  public Range(Location f)
    {
    first = new Location(f.num,     f.line, f.col);
    last  = new Location(f.num - 1, f.line, f.col - 1);  // Make it a zero-length range.
    }

  public Range(Location f, Location l)
    {
      first = new Location(f.num, f.line, f.col);
      last  = new Location(l.num, l.line, l.col);  
    }

  public void finish(Location l) { last = l; }

/* ------------------------------------------------------------------------- */

  public String toString()
    {
    int length = last.num - first.num + 1;

    if (length < 0)   // We haven't yet set its last coordinates.
      return "line " + String.valueOf(first.line) + " starting at char " + String.valueOf(first.col);
    else if (length == 0)
      return "line " + String.valueOf(first.line) + " before char "      + String.valueOf(first.col);
    else if (length == 1)
      return "line " + String.valueOf(first.line) + " char "             + String.valueOf(first.col);
    else if (first.line == last.line)
      return "line " + String.valueOf(first.line) + " char " + String.valueOf(first.col) + " to " +
                                                                 String.valueOf( last.col);
    else
      return "line " + String.valueOf(first.line) + " char " + String.valueOf(first.col) + " to " +
             "line " + String.valueOf(last.line)  + " char " + String.valueOf( last.col);
    }
  }
