public class SymTable
  {
  private Entry last;
  
  // Remove the formal 
  public void exitProc()
    {
    Entry e = last;
    while (e != null && e.type == Type.FORMAL) e = e.prev;
    last = e;
    }
  
  // Adds a new Entry to the symbol table
  public void enter(String spelling, Decl d, int type)
    {
    Entry e = new Entry(spelling, d, type);
    e.prev = last;
    last = e;
    }

  // Looks for and returns an Entry whose name is same as spelling
  public Entry lookup(String spelling)
    {
    for (Entry e = last; e != null; e = e.prev)
      if (spelling.compareTo(e.spelling) == 0)
        return e;
    return null;
    }
  
  public String toString()
    {
    String result = "";
    for (Entry e = last; e != null; e = e.prev) result += e;
    return result;
    }
  }

